//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39A3E237032F.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39A3E237032F.cm

//## begin module%39A3E237032F.cp preserve=no
//## end module%39A3E237032F.cp

//## Module: EinsteinIO%39A3E237032F; Package body
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/DataFactory/EinsteinIO.cxx

//## begin module%39A3E237032F.additionalIncludes preserve=no
//## end module%39A3E237032F.additionalIncludes

//## begin module%39A3E237032F.includes preserve=yes
//## end module%39A3E237032F.includes

//## begin module%39A3E237032F.declarations preserve=no
//## end module%39A3E237032F.declarations

//## begin module%39A3E237032F.additionalDeclarations preserve=yes
#include <XSModel/DataFactory/EinsteinIO.h>
#include <XSUtil/Utils/XSutility.h>
#include <CCfits/CCfits>
#include <XSstreams.h>
#include <cstring>
//## end module%39A3E237032F.additionalDeclarations


// Class EinsteinIO 

EinsteinIO::EinsteinIO()
  //## begin EinsteinIO::EinsteinIO%39A3E3150250_const.hasinit preserve=yes
  : m_dataSource(static_cast<CCfits::FITS*>(0))
  //## end EinsteinIO::EinsteinIO%39A3E3150250_const.hasinit
  //## begin EinsteinIO::EinsteinIO%39A3E3150250_const.initialization preserve=yes
  //## end EinsteinIO::EinsteinIO%39A3E3150250_const.initialization
{
  //## begin EinsteinIO::EinsteinIO%39A3E3150250_const.body preserve=yes
  //## end EinsteinIO::EinsteinIO%39A3E3150250_const.body
}

EinsteinIO::EinsteinIO(const EinsteinIO &right)
  //## begin EinsteinIO::EinsteinIO%39A3E3150250_copy.hasinit preserve=yes
  : m_dataSource(static_cast<CCfits::FITS*>(0))
  //## end EinsteinIO::EinsteinIO%39A3E3150250_copy.hasinit
  //## begin EinsteinIO::EinsteinIO%39A3E3150250_copy.initialization preserve=yes
  //## end EinsteinIO::EinsteinIO%39A3E3150250_copy.initialization
{
  //## begin EinsteinIO::EinsteinIO%39A3E3150250_copy.body preserve=yes
  //## end EinsteinIO::EinsteinIO%39A3E3150250_copy.body
}


EinsteinIO::~EinsteinIO()
{
  //## begin EinsteinIO::~EinsteinIO%39A3E3150250_dest.body preserve=yes
  delete m_dataSource;
  //## end EinsteinIO::~EinsteinIO%39A3E3150250_dest.body
}



//## Other Operations (implementation)
void EinsteinIO::write (const string& fileName)
{
  //## begin EinsteinIO::write%39A3E42A0096.body preserve=yes
  //## end EinsteinIO::write%39A3E42A0096.body
}

size_t EinsteinIO::read (const string& fileName, bool readFlag)
{
  //## begin EinsteinIO::read%39A3E426001D.body preserve=yes
  return 1;  // for now
  //## end EinsteinIO::read%39A3E426001D.body
}

bool EinsteinIO::fileFormat (const string& fileName, XspecDataIO::DataType type)
{
  //## begin EinsteinIO::fileFormat%39AD452F0392.body preserve=yes
  // default implementation of fileFormat, detects SPECTRUM types.
  using namespace CCfits;
  static const string specExt = "SPECTRUM";
  static const string tele    = "TELESCOP";
  static char einstein[] = "EINSTEIN";
  bool form = false;
  try
  {
          std::auto_ptr<FITS> p(new FITS(fileName,Read,specExt));
          ExtHDU& spectrum = p->extension(specExt);
          string keyValue("");
          try 
          {
                spectrum.readKey(tele,keyValue);
                // it's an Einstein spectrum extension if keyValue == einstein
                form =  (strcasecmp(keyValue.c_str(),einstein) == 0);
                       
          }
          catch (HDU::NoSuchKeyword) 
          {
                  
          } 
  } 
  catch (FitsException& )
  {
          
  }

  return form;  
  //## end EinsteinIO::fileFormat%39AD452F0392.body
}

void EinsteinIO::channelBounds (int& startChannel, int& endChannel, size_t row) const
{
  //## begin EinsteinIO::channelBounds%39FDAD42002E.body preserve=yes
  //## end EinsteinIO::channelBounds%39FDAD42002E.body
}

void EinsteinIO::closeFile ()
{
  //## begin EinsteinIO::closeFile%3A3941A7019B.body preserve=yes
  delete m_dataSource;
  m_dataSource = 0;  
  //## end EinsteinIO::closeFile%3A3941A7019B.body
}

void EinsteinIO::swap (EinsteinIO& right)
{
  //## begin EinsteinIO::swap%3A95797C00B2.body preserve=yes
  XSutility::swap(m_dataSource,right.m_dataSource);
  //## end EinsteinIO::swap%3A95797C00B2.body
}

// Additional Declarations
  //## begin EinsteinIO%39A3E3150250.declarations preserve=yes
  //## end EinsteinIO%39A3E3150250.declarations

//## begin module%39A3E237032F.epilog preserve=yes
//## end module%39A3E237032F.epilog
